﻿package 
{
	import com.bit101.components.InputText;
	import com.bit101.components.Label;
	import com.bit101.components.Panel;
	import com.bit101.components.PushButton;
	import com.bit101.components.Slider;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	
	
	/**
	 * ...
	 * @author 
	 */
	public class Main extends Sprite 
	{
		private var points:Array;
		private var pointSelected:int;
		private var running:Boolean;
		private var time:Number;
		private var obj:Sprite;
		private var slider:Slider;
		private var FPS:int;
		private var frameLabel:Label;
		private var lastFrame: Number;
		private var paused:Boolean;
		
		public function Main():void 
		{
			paused = false;
			FPS = 30;
			obj = new Sprite;
			addChild(obj);
			obj.graphics.lineStyle(2, 0);
			obj.graphics.drawRect( -5, -5, 10, 10);
			obj.x = -10;
			running = false;
			points = new Array;
			points.push(new Sprite());
			points.push(new Sprite());
			points.push(new Sprite());
			points.push(new Sprite());
			points[0].x = 5;
			points[0].y = 100;
			points[1].x = 5;
			points[1].y = 5;
			points[2].x = 100;
			points[2].y = 5;
			points[3].x = 100;
			points[3].y = 100;
			pointSelected = -1;
			for (var i:int = 0; i < 4; ++i ) {
				points[i].graphics.lineStyle(1, 0);
				points[i].graphics.drawRect( -5, -5, 10, 10);
				addChild(points[i]);
			}	
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
			drawBezier();
			new PushButton(this, 300, 0, "Run", onRun);
			slider = new Slider(Slider.HORIZONTAL, this, 10, 280, onChangeFrame);
			slider.width = 300;
			slider.maximum = FPS;
			
			new PushButton(this, 300, 30, "Set FPS", onSetFps);
			frameLabel = new Label(this, 320, 275, "frame: 0"); 
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
			new PushButton(this, 300, 60, "Pause", onPause);
			new PushButton(this, 300, 90, "Next frame", onNextFrame);
			new PushButton(this, 300, 120, "Prev frame", onPrevFrame);
		}
		
		private function onSetFps(e:Event):void {
			var p:Panel = new Panel(this, 100, 100);
			p.width = 150;
			var f : InputText = new InputText(p, 25, 20, "Enter FPS");
			new PushButton(p, 25, 50, "Set", function():void {
				FPS = parseInt(f.text);
				slider.maximum = FPS;
				slider.minimum = 0;
				p.parent.removeChild(p);
			});
		}
		
		private function onNextFrame(e:Event):void {
			if(slider.value < slider.maximum) {
				slider.value = slider.value + 1;
				time = (slider.value / FPS) * 1000;
			}
		}

		private function onPrevFrame(e:Event):void {
			if(slider.value > 0) {
				slider.value = slider.value - 1;
				time = (slider.value / FPS) * 1000;
			}
		}
		
		private function onChangeFrame(e:Event):void {
			time = (slider.value / FPS) * 1000;
		}
		
		private function onEnterFrame(e:Event):void {
			var date:Date = new Date;
			var now:Number = date.getTime();
			/*if (running) */{
				trace(now);
				
				if(!paused && time <= 1000)
					time += now - lastFrame;
				lastFrame = now;
				slider.value = FPS * time / 1000;
				frameLabel.text = Math.floor(FPS*time/1000).toString();
				if (time > 1000) {
					graphics.clear();
					graphics.lineStyle(2, 0);
					var s:Number = getSFromT(Math.floor(FPS * time / 1000) / FPS);
					var p:Point = getBezier(s);
					obj.x = p.x;
					obj.y = p.y;
					obj.rotation = getTangent(s);
					frameLabel.text = FPS.toString();
					running = false;
					drawBezier();
				}
				else {
					graphics.clear();
					graphics.lineStyle(2, 0);
					s = getSFromT(Math.floor(FPS * time / 1000) / FPS);
					p = getBezier(s);
					obj.x = p.x;
					obj.y = p.y;
					obj.rotation = getTangent(s);
				}
			}
			/*else 
				lastFrame = now;*/
			
		}
		
		private function onPause(e:Event):void {
			paused = true;
		}
		
		private function onRun(e:Event):void {
			running = true;
			if(!paused)
				time = 0;
			paused = false;
			var date:Date = new Date;
			lastFrame = date.getTime();
		}
		
		private function onMouseDown(e:MouseEvent):void {
			for (var i:int = 0; i < 4; ++i ) {
				if (e.stageX > points[i].x - 5 && e.stageX < points[i].x + 5 && e.stageY > points[i].y - 5 && e.stageY < points[i].y + 5)
					pointSelected = i;
			}
		}
		
		private function onMouseMove(e:MouseEvent):void {
			if (pointSelected != -1) {
				points[pointSelected].x = e.stageX;
				points[pointSelected].y = e.stageY;
				drawBezier();
			}
		}

		private function onMouseUp(e:MouseEvent):void {
			pointSelected = -1;
			drawBezier();
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			stage.addEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);
			stage.addEventListener(MouseEvent.MOUSE_UP, onMouseUp);
			stage.addEventListener(MouseEvent.MOUSE_MOVE, onMouseMove);
			
			// entry point
		}
		
		private function getBetween(p1:Point, p2:Point, s:Number):Point {
			return new Point((1 - s) * p1.x + s * (p2.x), (1 - s) * p1.y + s * (p2.y));
		}

		private function getBetweenS(p1:Sprite, p2:Sprite, s:Number):Point {
			return new Point((1 - s) * p1.x + s * (p2.x), (1 - s) * p1.y + s * (p2.y));
		}
		
		
		private function getTangent(s:Number):Number {
			var p12:Point = getBetweenS(points[1], points[2], s);
			var A:Point = getBetween(getBetweenS(points[0], points[1], s), p12, s);
			var B:Point = getBetween(p12, getBetweenS(points[2], points[3], s), s);
			var dy:Number = B.y - A.y;
			var dx:Number = B.x - A.x;
			var ret:Number =  Math.atan2(dy, dx)*180/Math.PI;
			return ret;
		}
		
		private function getBezier(s:Number):Point {
			var ret:Point = new Point();
			ret.x += Math.pow(1 - s, 3) * Math.pow(s, 0) * points[0].x;
			ret.x += 3*Math.pow(1 - s, 2) * Math.pow(s, 1) * points[1].x;
			ret.x += 3*Math.pow(1 - s, 1) * Math.pow(s, 2) * points[2].x;
			ret.x += Math.pow(1 - s, 0) * Math.pow(s, 3) * points[3].x;
			
			ret.y += Math.pow(1 - s, 3) * Math.pow(s, 0) * points[0].y;
			ret.y += 3*Math.pow(1 - s, 2) * Math.pow(s, 1) * points[1].y;
			ret.y += 3*Math.pow(1 - s, 1) * Math.pow(s, 2) * points[2].y;
			ret.y += Math.pow(1 - s, 0) * Math.pow(s, 3) * points[3].y;
			return ret;
		}
		
		private function getSFromT(t:Number):Number {
			if (t <= 0)
				return 0;
			if (t >= 1)
				return 1;
			var ps:Array = new Array;
			var sum:Number = 0;
			for (var s:Number = 0; s <= 1.01; s += 0.04 ) {
				ps.push(getBezier(s));
				if (ps.length > 1) {
					sum += Point.distance(ps[ps.length-1], ps[ps.length-2]);
				}
			}
			var i:int = 0;
			var a:Number = 0;
			while ( i < ps.length && a + Point.distance(ps[i], ps[i+1]) / sum < t) {
				a += Point.distance(ps[i], ps[i+1]) / sum;
				++i;
			}
			if (i < ps.length) {
				var ret:Number = 0.04 * i;
				t -= a;
				ret +=  0.04 * t / ((Point.distance(ps[i], ps[i + 1])/sum)); 
				return ret;
			}
			return 0;
		}
		
		private function drawBezier():void {
			graphics.clear();
			graphics.lineStyle(1, 0);
			graphics.moveTo(points[0].x, points[0].y);
			for (var s:Number = 0; s <= 1; s += 0.01 ) {
				var p:Point = getBezier(s);
				graphics.lineTo(p.x, p.y);
			}
		}
	}
	
}